package jsetlPaperPrograms.usingRIS2020;

import jsetl.*;
import jsetl.exception.Failure;

public class Es13_MinimumPartiallySpecified {

	private static Solver solver = new Solver();

	public static LVar minValue(LSet S) throws Failure {
		IntLVar x = new IntLVar(), m = new IntLVar();
		Ris R= new Ris(x,S,m.le(x));
		solver.add(m.in(S).and(S.subset(R)));
		solver.solve();
		return m;
	}

	public static void main (String[] args) throws Failure {
		IntLVar z = new IntLVar("z");
		LSet A = LSet.empty().ins(8,z,4,6);
		LVar min = minValue(A).setName("min");
		min.output();
		z.output();
		if(solver.nextSolution()) {
			min.output();
			z.output();
		}
		if(solver.nextSolution()) {//should not enter this
			min.output();
			z.output();
		}
	}
}

/*
_min = _z
_z = unknown, _z =< 4
_min = 4
_z = unknown, _z >= 4
*/