package jsetlPaperPrograms.usingRIS2020;

import jsetl.*;
import jsetl.exception.Failure;

public class Es14_MapColoring {

	private static Solver solver = new Solver();

	public static void coloring(LSet Rg, LSet Mp, LSet Cl)
		throws Failure {
		solver.add(Rg.subset(Cl));
		LSet P = new LSet();
		Ris R = new Ris(P, Mp, P.size(2));
		solver.add(Mp.subset(R));
		solver.solve();
	}

	public static void main (String[] args) throws Failure {
		LVar r1 = new LVar("r1"), r2 = new LVar("r2"), r3 = new LVar("r3");
		LSet regions = LSet.empty().ins(r1,r2,r3);
		LSet map = LSet.empty().ins(LSet.empty().ins(r1).ins(r2),LSet.empty().ins(r2).ins(r3));
		LSet colors = LSet.empty().ins("red","blue");

		coloring(regions,map,colors);

		r1.output();
		r2.output();
		r3.output();

		if(solver.nextSolution()) {
		r1.output();
		r2.output();
		r3.output();}

		if(solver.nextSolution()) {//shouldn't enter here
		r1.output();
		r2.output();
		r3.output();
		}
	 }
}

/*
_r1 = red
_r2 = blue
_r3 = red
_r1 = blue
_r2 = red
_r3 = blue
*/