package jsetlPaperPrograms.usingRIS2020;

import jsetl.*;
import jsetl.exception.Failure;
import java.util.Arrays;

public class Es17_MapListSquares {

	private static Solver solver = new Solver();

	public static void mapList(Integer[] A,LSet f) throws Failure {
		for(int i=0; i<A.length; i++) {
			IntLVar y = new IntLVar();
			solver.solve(new LPair(A[i],y).in(f));
			A[i] = y.getValue();
		}
	}

	public static void mapListRev(Integer[] A,LSet f) throws Failure {
		for(int i=0; i<A.length; i++) {
			IntLVar y = new IntLVar();
			if (solver.check(new LPair(y,A[i]).in(f)))
				System.out.println(A[i]);
		}
	}

	public static void main (String[] args) throws Failure {
		IntLVar x = new IntLVar();
		LSet D = new LSet();
		Ris sqr = new Ris(x,D,Constraint.truec(),new LPair(x,x.mul(x)));
		Integer[] elems = {3,5,7};
		mapList(elems,sqr);
		System.out.println(Arrays.asList(elems));

		Integer[] elems2 = {10,100,1000};
		mapListRev(elems2,sqr);
   }
}

/*
[9, 25, 49]
100
*/